<?php
/*
Plugin Name: Remote Images Grabber
Plugin URI: http://plus.eto-ya.com/remote-images-grabber
Description: Fetches images from an URL or a piece of html-code, saves them directly into your blog media directory, and attaches to the appointed post.
Author: Andrey K.
Version: 0.4
Author URI: http://andrey.eto-ya.com/
*/

/*  Copyright 2010 Andrey K. (email: v5@bk.ru, URL: http://andrey.eto-ya.com/)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA
*/

load_plugin_textdomain('rigr', PLUGINDIR.'/remote-images-grabber');

add_action('admin_menu', 'rigr_add_menu');

function rigr_add_menu() {
	add_media_page( __('Images Grabber'), __('Images Grabber'), 'upload_files', 'remote_images_grabber', $func = 'rigr_manager' );
}

function rigr_manager() {

	global $wpdb;

	if ( 'POST'== $_SERVER['REQUEST_METHOD'] )
	{
		$rigr_attach_to= $_POST['rigr_attach_to'];
		$rigr_attach_to= (int)$rigr_attach_to;

		$post= $wpdb->get_row("SELECT ID, post_date FROM $wpdb->posts WHERE ID=$rigr_attach_to", ARRAY_A);

		if ( !$post ) {
			$rigr_attach_to= 0;
		}
		
		$page_with_links= $_POST['rigr_page_with_links'];
	
		if ( '' != $page_with_links )
		{
			$tmpname= tempnam('/tmp', '');
			$headers= wp_get_http($page_with_links, $tmpname);

			if ( $headers['response'] && ( $headers['response'] != '200' ) )
			{
				echo '<p>Incorrect: ',$page_with_links,' - response ',$headers['response'], ', should be 200.</p>';
				$urls= array();
			}
			else
			{
				$s= file_get_contents($tmpname);
				echo '<p>',$page_with_links,' - ',strlen($s), ' bytes</p>';
			
			}

			unlink($tmpname);
		}
		else
		{
			$s= $_POST['rigr_list'];
		}

		$s= str_replace('><', '> <', $s);

		$find_in_tags= array();

		if ( $_POST['rigr_hrefs'] )
			$find_in_tags['a']= array('href'=>1);

		if ( $_POST['rigr_srcs'] )
			$find_in_tags['img']= array('src'=>1);

		$s= wp_kses($s, $find_in_tags );

		preg_match_all('/http:\/\/[a-z0-9;=_%\/\Q?&.-\E]+/is', $s, $allurls);

		$urls= array();

		foreach ($allurls[0] as $u) {
			if ( preg_match('/(jpg|jpeg|gif|png)/i', $u) )
					$urls[]= $u;
		}

		$rigr_list= array_unique($urls);

		if ( !count($rigr_list) )
		{
			echo '<p>'.__('Nothing to grab.', 'rigr').'</p>';
		}
		else foreach ($rigr_list as $k=>$v )
		{
			usleep(300000);		/* Let the remote server a short respite */

			$res[$k]= rigr_fetch_remote_file($post, $v);

			if ( is_object($res[$k]) && $res[$k]->errors ) {
				$out= array_values( $res[$k]->errors );
				$out= array_values( $out[0] );
				echo '<p>',$v, ' - error: ', $out[0], '</p>';
				//				print_r($out);
				continue;
			}
			
			if ( !empty($_POST['rigr_post_title']) ) {
				$title= wp_kses($_POST['rigr_post_title'], array()).(($k==0)?'':' - '.$k);
			}
			else {
				$title= basename($res[$k]['file']);
				if ( $dotpos= strpos($title, '.') )
					$title= substr($title, 0, $dotpos);
			}
			$att= array(
				'post_status'=>'publish', 'post_parent'=> $rigr_attach_to, 'ping_status' =>'closed', 'guid'=>$res[$k]['url'], 'post_title'=> $title, 'post_mime_type'=>$res[$k]['content-type'] );


			$att_ID= wp_insert_attachment($att);

			if ( !$att_ID ) {
				echo "<br />can not create attachment for $res[$k][file]<br />";
				continue;
			}

			wp_update_attachment_metadata($att_ID, wp_generate_attachment_metadata($att_ID, $res[$k]['file']));
			update_attached_file($att_ID, $res[$k]['file']);
			echo '<p>',$v, ' - OK </p>';
		}	

	}
?>

<div class="wrap">

<div id="icon-upload" class="icon32"></div>

<h2><?php _e('Remote Images Grabber', 'rigr'); ?></h2>

<form method="post" action="http://<?php echo $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'] ?>" name="rigr_form" id="rigr_form" >

<table style="vertical-align:top;">
<tr style="vertical-align:top">
<td>

<p><?php _e('List of URLS of remote images, or simply a piece of HTML-code:', 'rigr'); ?><br />

<textarea name="rigr_list" rows="13" cols="75"></textarea></p>
</td>
<td style="padding-left:10px; width:300px">
<p style="margin:0 0 0 0 !important"><?php _e('File size limit', 'rigr'); ?> <input type="text" name="rigr_max_size" value="<?php echo get_site_option('fileupload_maxk', 0); /* for wpmu compatibility */ ?>" size="4" /> KB
<small><br />(<?php _e('Leave 0 for no limit', 'rigr'); ?>)</small>
</p>

<p><input type="checkbox" name="rigr_hrefs" checked="checked" value="1" /><?php _e('Grab images from URLs in', 'rigr'); ?> <code>&lt;a&nbsp;href="...</code>?</p>

<p><input type="checkbox" name="rigr_srcs" checked="checked" /><?php _e('Grab images from URLs in', 'rigr'); ?> <code>&lt;img&nbsp;src="...</code>?<br />
<small><?php _e('If uncheck both the grabber strips all html-tags and finds images URLs in the rest of text.', 'rigr'); ?></small></p>
<p><small><?php _e('Grabber finds URLs of jpg, jpeg, gif, png files, sample:', 'rigr'); ?> http://domain.tld/path/myimage.jpg</small></p>

</p>

</td>
</tr>
</table>
<p><?php _e('Or the URL of a page with hyperlinks to images:', 'rigr'); ?>

<input type="text" name="rigr_page_with_links" size="60" /></p>

<p><?php _e('The post ID where images should be attached to:', 'rigr'); ?> <input type="text" name="rigr_attach_to" value="<?php echo (int)$_GET['attach_to']; ?>" size="5" />
<small><br />(<?php _e('if not set then images will be unattached', 'rigr'); ?>)</small>
</p>

<p><?php _e('The title for a file or file group:', 'rigr'); ?> <input type="text" name="rigr_post_title"  size="50" />
<small><br />(<?php _e('if not set, files names are used', 'rigr'); ?>)</small>
</p>

<p><br /><input type="submit" style="width:400px" class="button-primary" name="Submit" value=" <?php _e('Go!', 'rigr') ?> " /></p>
</form>

</div>
<?php
}

/* -- modified function from wp-admin/import/wordpress.php:~666 -- */

function rigr_fetch_remote_file($post, $url) {

		$url2= str_replace('&amp;', '&', $url);
		$upload = wp_upload_dir($post['post_date']);
		
		preg_match('/[a-z0-9%_-]+\.(jpg|jpeg|gif|png)/i', $url2, $pu);
		$file_name= $pu[0];

		$upload2 = wp_upload_bits( $file_name, 0, '', $post['post_date']);

		if ( $upload2['error'] ) {
			echo $upload2['error'];
			return new WP_Error( 'upload_dir_error', $upload2['error'] );
		}

		$headers = wp_get_http($url2, $upload2['file']);

		if ( ! $headers ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', __('Remote server did not respond', 'rigr') );
		}

		if ( $headers['response'] != '200' ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', sprintf(__('Remote server says: %1$d %2$s', 'rigr'), $headers['response'], get_status_header_desc($headers['response']) ) );
		}
		elseif ( isset($headers['content-length']) && filesize($upload2['file']) != $headers['content-length'] ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', __('Remote file is incorrect size', 'rigr') );
		}

		$max_size = max( (int)$_POST['rigr_max_size'], (int)get_site_option('fileupload_maxk') )*1024;
/* -- fileupload_maxk for wpmu compatibility -- */

		$file_size= filesize($upload2['file']);

		if ( !empty($max_size) && $file_size > $max_size ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', sprintf(__('Remote file is %1$d KB but limit is %2$d', 'rigr'), $file_size/1024, $max_size/1024) );
		}

/* -- This check is for wpmu compatibility -- */
		if ( function_exists('get_space_allowed') ) {
			$space_allowed = 1048576 * get_space_allowed();
			$space_used = get_dirsize( BLOGUPLOADDIR );
			$space_left = $space_allowed - $space_used;

			if ( $space_left < 0 ) {
				@unlink($upload2['file']);
				return new WP_Error( 'not_enough_diskspace', sprintf(__('You have %1$d KB diskspace used but %2$d allowed.', 'rigr'), $space_used/1024, $space_allowed/1024) );

			}
		}

		$upload2['content-type']= $headers['content-type'];
		return $upload2;

	}

?>
